// LLIDdoc.h : interface of the CLLIDDoc class
//
/////////////////////////////////////////////////////////////////////////////

class CLLIDDoc : public CDocument
{
protected: // create from serialization only
    CLLIDDoc();
    DECLARE_DYNCREATE(CLLIDDoc)

// Attributes
public:  

    // declare your LLI - object here
            
    LLOBJECT    lloImage,      // do zooming only on this Image
                lloOrigImage;  // keep a copy of the original image to 
                               // avoid reloading or loss of quality of
                               // the image after zoom or rotate

// Operations
public:

// Implementation
public:
    virtual ~CLLIDDoc();
    virtual void Serialize(CArchive& ar);   // overridden for document i/o
    
    // this member function returns the size of either the original    
    // or the current image ( TRUE = original )
    virtual CSize GetImageSize( BOOL OrigImage ); 
                                                  
#ifdef _DEBUG
    virtual void AssertValid() const;
    virtual void Dump(CDumpContext& dc) const; 
#endif

protected:
    virtual BOOL OnNewDocument();
    
    virtual void DeleteContents(); // clean up when closing or reopening a document

// Generated message map functions
protected:
 //{{AFX_MSG(CLLIDDoc)
    virtual BOOL OnOpenDocument( const char *pszPathName );
    virtual BOOL OnSaveDocument( const char *pszPathName );
    afx_msg void OnGenMosaic();
    //}}AFX_MSG
 DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
